import 'package:flutter/material.dart';
import 'reactter_inherit_provider.dart';
import 'reactter_inherit_provider_scope_element.dart';

/// Wrapper from [InheritedWidget].
///
/// Create a provider [ReactterInheritedProvider] to communicate [ReactterInheritedProviderScopeElement].
class ReactterInheritedProviderScope extends InheritedWidget {
  const ReactterInheritedProviderScope({
    required this.owner,
    required Widget child,
    Key? key,
  }) : super(key: key, child: child);

  final ReactterInheritedProvider owner;

  @override
  bool updateShouldNotify(InheritedWidget oldWidget) {
    return false;
  }

  @override
  ReactterInheritedProviderScopeElement createElement() {
    return ReactterInheritedProviderScopeElement(this);
  }
}
